/*
* $LastChangedBy$
* $LastChangedDate$
* $LastChangedRevision$
* $HeadURL$
*
* Copyright 2014 BlueConic Inc./BlueConic B.V. All rights reserved.
*/

import Foundation

@objc public class BlueConicEventFactory: NSObject {

    private static var __once: () = {
            StaticEvent.instance = BlueConicEventManager()
    }()

    private struct StaticEvent {
        static var onceToken: Int = 0
        static var instance: BlueConicEventManager!
    }

    private class var sharedInstance: BlueConicEventManager {

        // This is performed once
        _ = BlueConicEventFactory.__once
        return StaticEvent.instance
    }

    @objc public class func getInstance() -> BlueConicEventManager {
        return sharedInstance
    }
}
